_TITLE "Random File Maker"
DEFINT A-Z
CONST Num$ = "0123456789"
Dna$ = "GCAT"
HexNum$ = "0123456789ABCDEF"
Roman$ = "IVXLCDM"
FOR X = 48 TO 57
    NumbersAndAlpha$ = NumbersAndAlpha$ + CHR$(X) ' *** Numbers 0 through 9 ***
NEXT X
FOR X = 65 TO 90
    NumbersAndAlpha$ = NumbersAndAlpha$ + CHR$(X) ' *** Upper Case Letters ***
NEXT X
FOR X = 97 TO 122
    NumbersAndAlpha$ = NumbersAndAlpha$ + CHR$(X) ' *** Lower Case Letters ***
NEXT X
ON ERROR GOTO Oops
VIEW PRINT
CLS
SCREEN 0, , 1, 0
GOSUB TheViewer
SCREEN 0, , 0, 0
LOCATE 1, 25, 1
COLOR 9
PRINT "USER-DEFINED RANDOM FILE MAKER";
'
HowMany:
'
VIEW PRINT 3 TO 24
COLOR 14
CLS
GOSUB Prompt1
COLOR 2
PRINT "How Many Bytes (Size of File): ";
COLOR 14
LINE INPUT ; HowMany$
HowMany$ = LTRIM$(RTRIM$(HowMany$))
IF HowMany$ = "" THEN
    VIEW PRINT
    COLOR 7
    CLS
    SYSTEM
ELSEIF LEFT$(HowMany$, 1) = "0" THEN
    GOTO HowMany
ELSEIF VAL(HowMany$) > &H7FFFFFFF THEN
    GOTO HowMany
ELSE
    FOR X = 1 TO LEN(HowMany$)
        IF INSTR(Num$, MID$(HowMany$, X, 1)) = 0 THEN
            GOTO HowMany
        END IF
    NEXT X
END IF
HowMany& = VAL(HowMany$)
'
UserKeyOrTimer:
'
VIEW PRINT 5 TO 24
COLOR 14
CLS
GOSUB Prompt2
PRINT "<T>";
COLOR 2
PRINT "imer or ";
COLOR 14
PRINT "<U>";
COLOR 2
PRINT "ser entered Key: ";
DO
    _LIMIT 25
    How$ = UCASE$(INKEY$)
    IF LEN(How$) THEN
        IF How$ = CHR$(13) THEN
            GOTO HowMany
        ELSEIF INSTR("TU", How$) THEN
            EXIT DO
        END IF
    END IF
LOOP
COLOR 14
PRINT "<"; How$; ">";
IF How$ = "T" THEN
    MyKey! = TIMER
    Seconds = VAL(RIGHT$(TIME$, 2))
    IF Seconds / 2 = INT(Seconds / 2) THEN
        MyKey! = -MyKey!
    END IF
    MyKey$ = STR$(MyKey!)
    Offset = 0
    FOR X = 1 TO LEN(MyKey$)
        Offset = Offset + VAL(MID$(MyKey$, X, 1))
    NEXT X
    COLOR 2
    PRINT " (Key:";
    COLOR 14
    IF MyKey! < 0 THEN
        PRINT SPC(1);
    END IF
    PRINT MyKey!;
    COLOR 2
    PRINT "Sub-Key: ";
    COLOR 14
    PRINT MID$(STR$(Offset), 2);
    COLOR 2
    PRINT ")";
END IF
'
WhatChoice:
'
Dna = 0
Hex = 0
Roman = 0
NumsAndAlph = 0
VIEW PRINT 7 TO 24
COLOR 14
CLS
GOSUB Prompt2
PRINT "<D>";
COLOR 2
PRINT "na, ";
COLOR 14
PRINT "<H>";
COLOR 2
PRINT "exidecimal, ";
COLOR 14
PRINT "<N>";
COLOR 2
PRINT "umbers/Alpha, ";
COLOR 14
PRINT "<R>";
COLOR 2
PRINT "oman Numerals or ";
COLOR 14
PRINT "<S>";
COLOR 2
PRINT "tandard: ";
COLOR 14
DO
    _LIMIT 25
    Choice$ = UCASE$(INKEY$)
    IF LEN(Choice$) THEN
        IF Choice$ = CHR$(13) THEN
            GOTO UserKeyOrTimer
        ELSEIF INSTR("DHNRS", Choice$) THEN
            EXIT DO
        END IF
    END IF
LOOP
PRINT "<"; Choice$; ">";
IF Choice$ = "D" THEN
    Dna = -1
ELSEIF Choice$ = "H" THEN
    Hex = -1
ELSEIF Choice$ = "N" THEN
    NumsAndAlph = -1
ELSEIF Choice$ = "R" THEN
    Roman = -1
END IF
IF Choice$ = "S" THEN
    GOTO MinimumASCII
ELSEIF How$ = "U" THEN
    GOTO HideOrNot
ELSE
    GOTO MakeFile
END IF
'
MinimumASCII:
'
VIEW PRINT 9 TO 24
COLOR 14
CLS
GOSUB Prompt2
COLOR 2
PRINT "Minimum ASCII Value ("; CHR$(242); " 0 and "; CHR$(243); " 254) OR ";
COLOR 14
PRINT "<?>";
COLOR 2
PRINT " = Special ASCII Viewer: ";
COLOR 14
LINE INPUT ; MinASC$
MinASC$ = LTRIM$(RTRIM$(MinASC$))
IF MinASC$ = "" THEN
    GOTO WhatChoice
ELSEIF MinASC$ = "?" THEN
    SCREEN 0, , 1, 1
    LOCATE 24, 40
    WHILE INKEY$ = ""
        _LIMIT 25
    WEND
    SCREEN 0, , 0, 0
    GOTO MinimumASCII
ELSEIF VAL(MinASC$) > 254 THEN
    GOTO MinimumASCII
ELSE
    FOR X = 1 TO LEN(MinASC$)
        IF INSTR(Num$, MID$(MinASC$, X, 1)) = 0 THEN
            GOTO MinimumASCII
        END IF
    NEXT X
END IF
MinASC = VAL(MinASC$)
'
MaximumASCII:
'
VIEW PRINT 11 TO 24
COLOR 14
CLS
GOSUB Prompt2
COLOR 2
PRINT "Maximum ASCII Value (> "; MinASC$; " & "; CHR$(243); " 255) OR ";
COLOR 14
PRINT "<?>";
COLOR 2
PRINT " = Special ASCII Viewer: ";
COLOR 14
LINE INPUT ; MaxASC$
MaxASC$ = LTRIM$(RTRIM$(MaxASC$))
IF MaxASC$ = "" THEN
    GOTO MinimumASCII
ELSEIF MaxASC$ = "?" THEN
    SCREEN 0, , 1, 1
    LOCATE 24, 40
    WHILE INKEY$ = ""
        _LIMIT 25
    WEND
    SCREEN 0, , 0, 0
    GOTO MaximumASCII
ELSEIF VAL(MaxASC$) <= MinASC THEN
    GOTO MaximumASCII
ELSEIF VAL(MaxASC$) > 255 THEN
    GOTO MaximumASCII
ELSE
    FOR X = 1 TO LEN(MinASC$)
        IF INSTR(Num$, MID$(MaxASC$, X, 1)) = 0 THEN
            GOTO MaximumASCII
        END IF
    NEXT X
END IF
MaxASC = VAL(MaxASC$)
IF How$ = "T" THEN
    GOTO MakeFile
END IF
'
HideOrNot:
'
VIEW PRINT 13 TO 24
COLOR 14
CLS
GOSUB Prompt2
COLOR 2
PRINT "Hide Following Entries? (Y/N): ";
COLOR 14
DO
    _LIMIT 25
    Hide$ = UCASE$(INKEY$)
    IF LEN(Hide$) THEN
        IF Hide$ = CHR$(13) THEN
            IF Choice$ = "S" THEN
                GOTO MaximumASCII
            ELSE
                GOTO WhatChoice
            END IF
        ELSEIF INSTR("YN", Hide$) THEN
            EXIT DO
        END IF
    END IF
LOOP
PRINT "<"; Hide$; ">";
IF Hide$ = "Y" THEN
    Hide = -1
ELSE
    Hide = 0
END IF
'
TheKey:
'
MaxLength = 7
VIEW PRINT 15 TO 24
COLOR 14
CLS
GOSUB Prompt2
COLOR 2
PRINT "Choose A Key Up to  7-Digits (Decimals OK): ";
COLOR 14
IF Hide THEN
    Column = POS(0)
    TheLine = CSRLIN
    Spaces = 80 - POS(0)
    GOSUB HideEntries
    MyKey$ = TheData$
    TheData$ = ""
ELSE
    LINE INPUT ; MyKey$
END IF
MyKey$ = LTRIM$(RTRIM$(MyKey$))
IF MyKey$ = "" THEN
    GOTO HideOrNot
ELSEIF LEN(MyKey$) > 1 THEN
    IF LEFT$(MyKey$, 1) = "0" THEN
        GOTO TheKey
    ELSEIF LEFT$(MyKey$, 1) = "-" AND MID$(MyKey$, 2, 1) = "0" THEN
        GOTO TheKey
    END IF
END IF
IF LEFT$(MyKey$, 1) = "-" THEN
    Start = 2
    MaxLength = MaxLength + 1
ELSE
    Start = 1
END IF
FOR X = 1 TO LEN(MyKey$)
    IF INSTR(".", MID$(MyKey$, X, 1)) THEN
        Decimal = X
        MaxLength = MaxLength + 1
        EXIT FOR
    END IF
NEXT X
IF LEN(MyKey$) > MaxLength THEN
    GOTO TheKey
ELSEIF Decimal = 0 THEN
    Decimal = LEN(MyKey$) + 1
END IF
FOR X = Start TO Decimal - 1
    IF INSTR(Num$, MID$(MyKey$, X, 1)) = 0 THEN
        GOTO TheKey
    END IF
NEXT X
FOR X = Decimal + 1 TO LEN(MyKey$)
    IF INSTR(Num$, MID$(MyKey$, X, 1)) = 0 THEN
        GOTO TheKey
    END IF
NEXT X
MyKey! = VAL(MyKey$)
'
TheOffset:
'
VIEW PRINT 17 TO 24
COLOR 14
CLS
GOSUB Prompt2
COLOR 2
PRINT "Choose An INTEGER Sub-Key ( 0 and  16384): ";
COLOR 14
IF Hide THEN
    Column = POS(0)
    TheLine = CSRLIN
    Spaces = 80 - POS(0)
    GOSUB HideEntries
    Offset$ = TheData$
    TheData$ = ""
ELSE
    LINE INPUT ; Offset$
END IF
Offset$ = LTRIM$(RTRIM$(Offset$))
IF Offset$ = "" THEN
    GOTO TheKey
ELSEIF VAL(Offset$) > 16384 THEN
    GOTO TheOffset
END IF
FOR X = 1 TO LEN(Offset$)
    IF INSTR(Num$, MID$(Offset$, X, 1)) = 0 THEN
        GOTO TheOffset
    END IF
NEXT X
Offset = VAL(Offset$)
'
MakeFile:
'
IF How$ = "T" THEN
    VIEW PRINT 13 TO 24
ELSE
    VIEW PRINT 19 TO 24
END IF
COLOR 14
CLS
GOSUB Prompt2
COLOR 2
PRINT "NEW File [d:][\path\]Filename[.ext]: ";
COLOR 14
LINE INPUT ; FileName$
FileName$ = LTRIM$(RTRIM$(FileName$))
IF FileName$ = "" THEN
    IF How$ = "T" THEN
        IF Choice$ = "S" THEN
            GOTO MaximumASCII
        ELSE
            GOTO WhatChoice
        END IF
    ELSE
        GOTO TheOffset
    END IF
ELSEIF _FILEEXISTS(FileName$) = -1 THEN
    GOTO MakeFile
END IF
RANDOMIZE USING MyKey!
FOR X& = 1 TO Offset
    Dummy! = RND
NEXT X&
LOCATE 24, 33
COLOR 23
PRINT "<Esc>";
COLOR 7
PRINT " to Abort"; SPC(4);
FileName = FREEFILE
TheData$ = SPACE$(1)
OPEN FileName$ FOR BINARY ACCESS WRITE AS #FileName LEN = 1
FOR X& = 1 TO HowMany&
    _DELAY .001
    IF NumsAndAlph THEN
        RndData = ASC(MID$(NumbersAndAlpha$, INT(62 * RND + 1), 1))
    ELSEIF Hex THEN
        RndData = ASC(MID$(HexNum$, INT(16 * RND + 1), 1))
    ELSEIF Roman THEN
        RndData = ASC(MID$(Roman$, INT(7 * RND + 1), 1))
    ELSEIF Dna THEN
        RndData = ASC(MID$(Dna$, INT(4 * RND + 1), 1))
    ELSE
        RndData = INT((MaxASC - MinASC + 1) * RND + MinASC)
    END IF
    TheData$ = CHR$(RndData)
    PUT #FileName, , TheData$
    FOR Y = 1 TO RndData
        Dummy! = RND
    NEXT Y
    IF How$ = "T" THEN
        LOCATE 15, 1, 0
    ELSE
        LOCATE 21, 1, 0
    END IF
    COLOR 2
    PRINT "Writing:";
    COLOR 14
    PRINT X&;
    COLOR 2
    PRINT "of";
    COLOR 14
    PRINT HowMany&;
    COLOR 2
    PRINT "Bytes";
    DO
        An$ = INKEY$
        IF LEN(An$) THEN
            IF An$ = CHR$(27) THEN
                CLOSE
                RUN
            END IF
            EXIT DO
        END IF
        EXIT DO
    LOOP
NEXT X&
CLOSE
RUN
'
Oops:
'
CLOSE
COLOR 15
IF ERR = 53 OR ERR = 64 OR ERR = 68 OR ERR = 76 THEN
    LOCATE 24, 7, 0
    PRINT "Problem With File Name and/or File Location - Hit ";
    COLOR 31
    PRINT "<Esc>";
    COLOR 15
    PRINT " to Resume";
    GOSUB WaitForKey
    RESUME MakeFile
END IF
LOCATE 24, 15, 0
PRINT "A Critical Error Has Occurred - Hit ";
COLOR 31
PRINT "<Esc>";
COLOR 15
PRINT " to Exit";
GOSUB WaitForKey
VIEW PRINT
COLOR 7
CLS
SYSTEM
'
WaitForKey:
'
DO
    _LIMIT 25
    An$ = INKEY$
    IF LEN(An$) THEN
        IF An$ = CHR$(27) THEN
            EXIT DO
        END IF
    END IF
LOOP
RETURN
'
Prompt1:
'
SavedLine = CSRLIN
LOCATE 24, 30
COLOR 7
PRINT "Hit ";
COLOR 23
PRINT "<Enter>";
COLOR 7
PRINT " to Quit";
LOCATE SavedLine, 2, 1
RETURN
'
Prompt2:
'
SavedLine = CSRLIN
LOCATE 24, 29
COLOR 7
PRINT "Hit ";
COLOR 23
PRINT "<Enter>";
COLOR 7
PRINT " to Go Back";
LOCATE SavedLine, 2, 1
COLOR 14
RETURN
'
HideEntries:
'
DO
    _LIMIT 25
    An$ = INKEY$
    IF LEN(An$) THEN
        IF LEN(An$) = 2 OR An$ = CHR$(13) THEN
            GOTO BypassEntry
        END IF
        TheData$ = TheData$ + An$
        IF An$ = CHR$(8) THEN
            IF LEN(TheData$) = 1 THEN
                TheData$ = ""
            ELSE
                TheData$ = MID$(TheData$, 1, LEN(TheData$) - 2)
                LOCATE TheLine, Column
                PRINT SPC(Spaces);
                VIEW PRINT TheLine + 1 TO 24
                CLS
                VIEW PRINT TheLine TO 24
                LOCATE TheLine, Column
                PRINT STRING$(LEN(TheData$), "*");
            END IF
        ELSE
            PRINT "*";
        END IF
        '
        BypassEntry:
        '
        IF An$ = CHR$(13) THEN
            EXIT DO
        END IF
    END IF
LOOP
RETURN
'
TheViewer:
'
VIEW PRINT
COLOR 14, 0
CLS
LOCATE 1, 24, 1
COLOR 9
PRINT "SPECIAL ASCII CHARACTERS VIEWER"
LOCATE 3, 1
COLOR 15
PRINT " Numbers, ASCII 48 through 57:"
PRINT
FOR X = 48 TO 57
    COLOR 2
    PRINT X; "= ";
    COLOR 14
    PRINT CHR$(X);
NEXT X
PRINT
PRINT
COLOR 15
PRINT " Upper Case Alphabet, ASCII 65 through 90:"
PRINT
FOR X = 65 TO 90
    COLOR 2
    PRINT X; "= ";
    COLOR 14
    PRINT CHR$(X);
NEXT X
PRINT
PRINT
COLOR 15
PRINT " Lower Case Alphabet, ASCII 97 through 122:"
PRINT
FOR X = 97 TO 122
    COLOR 2
    PRINT USING "###"; X;
    PRINT " = ";
    COLOR 14
    PRINT CHR$(X); " ";
NEXT X
LOCATE 24, 28
COLOR 7
PRINT "Hit ";
COLOR 23
PRINT "<Any>";
COLOR 7
PRINT " Key to Return";
RETURN



